import { ConnectionBackend, Http, Request, RequestOptions, RequestOptionsArgs, Response, XHRBackend } from '@angular/http';
import { Observable, Subject } from 'rxjs/Rx';
export declare class HttpInterceptorService extends Http {
    private pendingRequests;
    private pendingRequestsStatus;
    constructor(backend: ConnectionBackend, defaultOptions: RequestOptions);
    getPendingRequestStatusSubject(): Subject<boolean>;
    request(url: string | Request, options?: RequestOptionsArgs): Observable<Response>;
}
export declare function HttpInterceptorServiceFactory(backend: XHRBackend, defaultOptions: RequestOptions): HttpInterceptorService;
export declare let HttpInterceptorServiceFactoryProvider: {
    provide: typeof HttpInterceptorService;
    useFactory: (backend: XHRBackend, defaultOptions: RequestOptions) => HttpInterceptorService;
    deps: (typeof XHRBackend | typeof RequestOptions)[];
};
