/*
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS
 * FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR
 * COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER
 * IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
 * CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 */
"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var http_interceptor_service_1 = require("../http-interceptor.service");
var SpinnerComponent = (function () {
    function SpinnerComponent(http) {
        var _this = this;
        this.http = http;
        this.subscription = this.http
            .getPendingRequestStatusSubject()
            .subscribe(function (isSpinnerVisible) {
            _this.isSpinnerVisible = isSpinnerVisible;
        });
    }
    SpinnerComponent.prototype.ngOnDestroy = function () {
        this.subscription.unsubscribe();
    };
    return SpinnerComponent;
}());
SpinnerComponent.decorators = [
    { type: core_1.Component, args: [{
                selector: 'spinner',
                template: "\n      <div id=\"http-loader\" *ngIf=\"isSpinnerVisible\">\n          <div class=\"loader-bg\">\n              <div class=\"sk-cube-grid\">\n                  <div class=\"sk-cube sk-cube1\"></div>\n                  <div class=\"sk-cube sk-cube2\"></div>\n                  <div class=\"sk-cube sk-cube3\"></div>\n                  <div class=\"sk-cube sk-cube4\"></div>\n                  <div class=\"sk-cube sk-cube5\"></div>\n                  <div class=\"sk-cube sk-cube6\"></div>\n                  <div class=\"sk-cube sk-cube7\"></div>\n                  <div class=\"sk-cube sk-cube8\"></div>\n                  <div class=\"sk-cube sk-cube9\"></div>\n              </div>\n          </div>\n      </div>\n    ",
                styles: ["\n      #http-loader {\n          top: 0;\n          left: 0;\n          height: 100%;\n          width: 100%;\n          position: fixed;\n          z-index: 9999\n      }\n\n      .loader-bg {\n          height: 100%;\n          width: 100%;\n          position: absolute;\n          filter: alpha(opacity=70);\n          opacity: .7;\n          background-color: #f1f1f1\n      }\n\n      .sk-cube-grid {\n          width: 40px;\n          height: 40px;\n          margin: 100px auto;\n      }\n\n      .sk-cube-grid .sk-cube {\n          width: 33%;\n          height: 33%;\n          background-color: #333;\n          float: left;\n          -webkit-animation: sk-cubeGridScaleDelay 1.3s infinite ease-in-out;\n          animation: sk-cubeGridScaleDelay 1.3s infinite ease-in-out;\n      }\n\n      .sk-cube-grid .sk-cube1 {\n          -webkit-animation-delay: 0.2s;\n          animation-delay: 0.2s;\n      }\n\n      .sk-cube-grid .sk-cube2 {\n          -webkit-animation-delay: 0.3s;\n          animation-delay: 0.3s;\n      }\n\n      .sk-cube-grid .sk-cube3 {\n          -webkit-animation-delay: 0.4s;\n          animation-delay: 0.4s;\n      }\n\n      .sk-cube-grid .sk-cube4 {\n          -webkit-animation-delay: 0.1s;\n          animation-delay: 0.1s;\n      }\n\n      .sk-cube-grid .sk-cube5 {\n          -webkit-animation-delay: 0.2s;\n          animation-delay: 0.2s;\n      }\n\n      .sk-cube-grid .sk-cube6 {\n          -webkit-animation-delay: 0.3s;\n          animation-delay: 0.3s;\n      }\n\n      .sk-cube-grid .sk-cube7 {\n          -webkit-animation-delay: 0s;\n          animation-delay: 0s;\n      }\n\n      .sk-cube-grid .sk-cube8 {\n          -webkit-animation-delay: 0.1s;\n          animation-delay: 0.1s;\n      }\n\n      .sk-cube-grid .sk-cube9 {\n          -webkit-animation-delay: 0.2s;\n          animation-delay: 0.2s;\n      }\n\n      @-webkit-keyframes sk-cubeGridScaleDelay {\n          0%, 70%, 100% {\n              -webkit-transform: scale3D(1, 1, 1);\n              transform: scale3D(1, 1, 1);\n          }\n          35% {\n              -webkit-transform: scale3D(0, 0, 1);\n              transform: scale3D(0, 0, 1);\n          }\n      }\n\n      @keyframes sk-cubeGridScaleDelay {\n          0%, 70%, 100% {\n              -webkit-transform: scale3D(1, 1, 1);\n              transform: scale3D(1, 1, 1);\n          }\n          35% {\n              -webkit-transform: scale3D(0, 0, 1);\n              transform: scale3D(0, 0, 1);\n          }\n      }\n    "]
            },] },
];
/** @nocollapse */
SpinnerComponent.ctorParameters = function () { return [
    { type: http_interceptor_service_1.HttpInterceptorService, },
]; };
exports.SpinnerComponent = SpinnerComponent;
//# sourceMappingURL=spinner.component.js.map